#include <bits/stdc++.h>
using namespace std;
typedef long long LL;

int N;
int input[5100];
int moveto[5100];
int color[5100];

void simulate()
{
	int hands[1010][6];
	for (int i = 0; i < N; ++i) {
		hands[i][0] = input[2*i];
		hands[i][1] = input[2*i+1];
		hands[i][2] = input[2*N + 2*i];
		hands[i][3] = input[2*N + 2*i+1];
		hands[i][4] = input[4*N + i];
	}

	int k = 5*N;
	for (int i = N-1; i >= 0; --i) {
		for (int j = 4; j >= 0; --j) {
			moveto[hands[i][j]] = --k;
		}
	}
}

int colorize(int col, int u)
{
	if (color[u] != 0) return 0;
	color[u] = col;
	return 1 + colorize(col, input[moveto[u]]);
}

void find_cycles()
{
	memset(color, 0, sizeof color);
	for (int i = 0; i < 5*N; ++i) {
		int size = colorize(i+1, i);
		if (size != 0) {
			printf("found a component of %d size\n", size);
		}
	}
}

LL player_win(int p)
{
	int nums[] = {0,1,2,3,4};
	int from[] = {p*2, p*2+1, 2*N + p*2, 2*N + p*2+1, 4*N+p};
	do {
		if (color[nums[0]] != color[input[from[0]]])
			;
	} while (next_permutation(nums, nums+5));
	return -1;
}

int main()
{
	while (true) {
		scanf("%d", &N);
		if (!N) break;
		for (int i = 0; i < 5*N; ++i) {
			scanf("%d", &input[i]);
			input[i] -= 1;
		}
		simulate();
		find_cycles();
	}
	return 0;
}
